=== src/atfstk/Makefile ===
## Copyright (C) 1993,1994 by the author(s).
# 
# This software is published in the hope that it will be useful, but
# WITHOUT ANY WARRANTY for any part of this software to work correctly
# or as described in the manuals. See the ShapeTools Public License
# for details.
#
# Permission is granted to use, copy, modify, or distribute any part of
# this software but only under the conditions described in the ShapeTools 
# Public License. A copy of this license is supposed to have been given
# to you along with ShapeTools in a file named LICENSE. Among other
# things, this copyright notice and the Public License must be
# preserved on all copies.

#
# Makefile for AtFS toolkit library (AtFStk)
#
# Authors: Andreas Lampen (Andreas.Lampen@cs.tu-berlin.de)
#          Axel Mahler (Axel.Mahler@cs.tu-berlin.de)
#
# $Header: Makefile[7.0] Thu Jul 29 18:36:35 1993 andy@cs.tu-berlin.de frozen $
#

# --------------------------------------------------------------------
#		locations and general macros
# --------------------------------------------------------------------

# The base directory of the project's repository area.

BASE = /home/stone/shape/development

# Path to this node system relative to the root of the
# repository area defined above (e.g. src/vc/save).

NODEPATH = src/atfstk

# A short name for this node system

NODENAME = AtFStk

# The operating system, $(TARGET) shall be built for.

HOSTSYSTEM = s_sunos_4

# The processor type.

HOSTTYPE = sun4

# Preprocessor switches. (eg. -DDEBUG)

SWITCHES = 

# Locations and modes for the installation of executables, header
# files, libraries and manuals.

INSTALLBASE = /home/stone/shape
INSTALLBINPATH = $(INSTALLBASE)/bin
INSTALLBINMODE = 755
INSTALLINCPATH = $(INSTALLBASE)/include
INSTALLINCMODE = 444
INSTALLLIBPATH = $(INSTALLBASE)/lib
INSTALLSHAPELIBPATH = $(INSTALLBASE)/lib/shape
INSTALLLIBMODE = 644
INSTALLMANPATH = $(INSTALLBASE)/man
INSTALLMANMODE = 444

# Directories, where local libraries and header files are to be
# installed for project wide use.

LOCALLIBPATH     = $(BASE)/lib
# special treatment due to problems in ShapeTools
# installation procedure. LOCALLIBPATH may be redefined
# from above.
MYLIBPATH        = $(BASE)/lib
LOCALINCLUDEPATH = $(BASE)/include

# --------------------------------------------------------------------
#		the system's components
# --------------------------------------------------------------------

#
# The system (program, library, etc.) to be built. If you want to
# manage multiple programs, you should introduce multiple targets
# (like PROGTARGET LIBTARGET or any better names). In this case you 
# have to adjust the system building actions accordingly.

PROGTARGET = vbind
LIBTARGET = libAtFStk.a

# The release number generator. The version number of this file will
# be used as release identifier for the whole system.

VERSIONFILE = atfstk_vers.c	# source
VERSIONOBJECT =	atfstk_vers.o	# derived (if source contains program code)

# The names of the subdirectories containing subsystems which are also
# to be built.

SUBSYSTEMS = 

# Aliases for (filesystem links to) $(TARGET).

ALIASES = 

# The regular source and header files.

SOURCES = atfstk_lib.c attrs.c version.c user.c uda.c citeattr.c \
	lock.c cache.c network.c read.c \
	bind.c bind_options.c bind_scan.c bind_rules.c bind_attr.c \
	vbind.c BindRules

HEADERS = atfstk.h bind.h

# Auxiliary source and header files that are not genuine part of the
# system (eg. a test environment). These will also be processed on
# system building, but will *not* be included in releases.

AUXSOURCES = 

AUXHEADERS = 

# Sources of variant source components stored under equal names in
# different locations. During system builds, only one of each (equally
# named) group is chosen. Source distributions need all of them.

VARIANTSOURCES =

VARIANTHEADERS =

# The manuals

MANUALS = $(MAN1) $(MAN3) $(MAN4) $(MAN5) $(MAN6) $(MAN7) $(MAN8)
MAN1 = vbind.1
MAN3 = atfstkintro.3 atattribute.3 atbind.3 atbindrule.3 atcache.3 \
	atclass.3 atexpand.3 atlog.3 atnetwork.3 atprint.3 \
	atread.3 atuser.3 atversion.3
MAN4 = 
MAN5 = 
MAN6 = 
MAN7 = bindrules.7
MAN8 = 

# All source components of the system (should not be changed)

COMPONENTS = $(SOURCES) $(HEADERS) $(MANUALS) Shapefile Makefile Dependencies

# The derived files. All files, that are automatically produced during
# a build process should be listed here.

LIBOBJECTS = atfstk_lib.o attrs.o version.o user.o uda.o citeattr.o \
	lock.o cache.o network.o read.o \
	bind.o bind_options.o bind_scan.o bind_rules.o bind_attr.o \
	$(VERSIONOBJECT)

PROGOBJECTS = vbind.o

OBJECTS = $(LIBOBJECTS) $(PROGOBJECTS)

# --------------------------------------------------------------------
#		tools, flags, libraries etc.
# --------------------------------------------------------------------

MAKE = make
SHELL = /bin/sh

INCLUDES = -I$(LOCALINCLUDEPATH)
MAKECFLAGS = -g
MAKELDFLAGS = -g

CC = cc
CFLAGS  = $(INCLUDES) $(MAKECFLAGS) $(SWITCHES)
LDFLAGS = $(MAKELDFLAGS)

RANLIB  = /usr/bin/ranlib

# System libraries, local libraries and lint libraries.

SYSLIBS   =
LOCALLIBS = $(MYLIBPATH)/libsttk.a $(MYLIBPATH)/libAtFS.a
LINTLIBS  =

# --------------------------------------------------------------------
#			the targets
# --------------------------------------------------------------------

# The default action (do not change)

all: +all $(ALLTARGETS)

# The final system building action.

targets: $(LIBTARGET) $(PROGTARGET)

$(LIBTARGET): $(LIBOBJECTS)
	-ar ruv $(LIBTARGET) $(LIBOBJECTS)
	@-($(RANLIB) $(LIBTARGET)) 2> /dev/null; true

$(PROGTARGET): $(LOCALLIBS) $(PROGOBJECTS) $(LIBOBJECTS)
	$(CC) $(LDFLAGS) -o $(PROGTARGET) $(PROGOBJECTS) \
		$(LIBOBJECTS) $(LOCALLIBS) $(SYSLIBS)
	@_aliases="$(ALIASES)"; \
	for i in $$_aliases; \
	do \
	  rm -f $$i; \
	  echo linking $(PROGTARGET) to $$i; \
	  ln $(PROGTARGET) $$i; \
	done

localinstalltargets: $(LOCALLIBPATH)/$(LIBTARGET) \
		$(LOCALINCLUDEPATH)/atfstk.h $(PROGTARGET)

$(LOCALLIBPATH)/$(LIBTARGET): $(LIBTARGET)
	@-echo "Copying $(LIBTARGET) to $(LOCALLIBPATH)"; \
	if [ -f $(LOCALLIBPATH)/$(LIBTARGET) ] ;\
	then \
	mv -f $(LOCALLIBPATH)/$(LIBTARGET) \
	      $(LOCALLIBPATH)/$(LIBTARGET).old;\
	fi; \
	cp $(LIBTARGET) $(LOCALLIBPATH)/$(LIBTARGET); \
	chmod $(INSTALLLIBMODE) $(LOCALLIBPATH)/$(LIBTARGET); \
	($(RANLIB) $(LOCALLIBPATH)/$(LIBTARGET)) 2> /dev/null; true

$(LOCALINCLUDEPATH)/atfstk.h: atfstk.h
	@-echo "Copying atfstk.h to $(LOCALINCLUDEPATH)"; \
	if [ -f $(LOCALINCLUDEPATH)/atfstk.h ] && \
	   [ ! -w $(LOCALINCLUDEPATH)/atfstk.h ]; \
	then \
	  chmod u+w $(LOCALINCLUDEPATH)/atfstk.h; \
	fi; \
	cp atfstk.h $(LOCALINCLUDEPATH)/atfstk.h; \
	chmod $(INSTALLINCMODE) $(LOCALINCLUDEPATH)/atfstk.h

installtargets: $(INSTALLLIBPATH)/$(LIBTARGET) $(INSTALLINCPATH)/atfstk.h \
	$(INSTALLBINPATH)/$(PROGTARGET) $(INSTALLSHAPELIBPATH)/BindRules

$(INSTALLLIBPATH)/$(LIBTARGET): $(LIBTARGET)
	@-echo "installing $(LIBTARGET) in $(INSTALLLIBPATH)"; \
	if [ -f $(INSTALLLIBPATH)/$(LIBTARGET) ] ;\
	then \
	mv -f $(INSTALLLIBPATH)/$(LIBTARGET) \
	      $(INSTALLLIBPATH)/$(LIBTARGET).old;\
	fi; \
	cp $(LIBTARGET) $(INSTALLLIBPATH)/$(LIBTARGET); \
	chmod $(INSTALLLIBMODE) $(INSTALLLIBPATH)/$(LIBTARGET); \
	($(RANLIB) $(INSTALLLIBPATH)/$(LIBTARGET)) 2> /dev/null; true

$(INSTALLBINPATH)/$(PROGTARGET): $(PROGTARGET)
	@-echo "installing $(PROGTARGET) in $(INSTALLBINPATH)"; \
	if [ -f $(INSTALLBINPATH)/$(PROGTARGET) ] && \
	   [ ! -w $(INSTALLBINPATH)/$(PROGTARGET) ]; \
	then \
	  chmod u+w $(INSTALLBINPATH)/$(PROGTARGET); \
	fi; \
	cp $(PROGTARGET) $(INSTALLBINPATH)/$(PROGTARGET); \
	chmod $(INSTALLBINMODE) $(INSTALLBINPATH)/$(PROGTARGET); \
	_aliases="$(ALIASES)"; \
	for i in $$_aliases; \
	do \
	  rm -f $(INSTALLBINPATH)/$$i; \
	  echo "linking $(INSTALLBINPATH)/$(PROGTARGET) to $(INSTALLBINPATH)/$$i"; \
	ln $(INSTALLBINPATH)/$(PROGTARGET) $(INSTALLBINPATH)/$$i; \
	done

$(INSTALLINCPATH)/atfstk.h: atfstk.h
	@-echo "Installing atfstk.h in $(INSTALLINCPATH)"; \
	if [ -f $(INSTALLINCPATH)/atfstk.h ] && \
	   [ ! -w $(INSTALLINCPATH)/atfstk.h ]; \
	then \
	  chmod u+w $(INSTALLINCPATH)/atfstk.h; \
	fi; \
	cp atfstk.h $(INSTALLINCPATH)/atfstk.h; \
	chmod $(INSTALLINCMODE) $(INSTALLINCPATH)/atfstk.h

$(INSTALLSHAPELIBPATH)/BindRules: BindRules
	@-echo "Installing BindRules in $(INSTALLSHAPELIBPATH)"; \
	if [ -f $(INSTALLSHAPELIBPATH)/BindRules ] && \
	   [ ! -w $(INSTALLSHAPELIBPATH)/BindRules ]; \
	then \
	  chmod u+w $(INSTALLSHAPELIBPATH)/BindRules; \
	fi; \
	cp BindRules $(INSTALLSHAPELIBPATH)/BindRules; \
	chmod $(INSTALLLIBMODE) $(INSTALLSHAPELIBPATH)/BindRules

installmanuals: $(MANUALS)
	@-_manuals="$(MAN1)"; \
	for i in $$_manuals; \
	do \
	  echo "installing $$i in $(INSTALLMANPATH)/man1"; \
	  if [ -f $(INSTALLMANPATH)/man1/$$i ] && \
	     [ ! -w $(INSTALLMANPATH)/man1/$$i ]; \
	  then \
	    chmod u+w $(INSTALLMANPATH)/man1/$$i; \
	  fi; \
	  cp $$i $(INSTALLMANPATH)/man1/$$i; \
	  chmod $(INSTALLMANMODE) $(INSTALLMANPATH)/man1/$$i; \
	done

noinstall: $(INSTALLBINPATH)/$(PROGTARGET) $(INSTALLSHAPELIBPATH)/BindRules

# The cleanup action. Removes all automatically rederivable files.

doclean:
	rm -f $(LIBTARGET) $(PROGTARGET) $(ALIASES) $(LIBOBJECTS) \
		$(PROGOBJECTS)

# Recursive builds. Performed *before* building $(TARGET)

subsystems:
	@_subsystems="$(SUBSYSTEMS)"; \
	for i in $$_subsystems; \
	do \
	  echo cd $$i; \
	  (cd $$i; $(MAKE) \
		BASE=$(BASE) \
		HOSTSYSTEM=$(HOSTSYSTEM) \
		HOSTTYPE=$(HOSTTYPE) \
		INSTALLBASE=$(INSTALLBASE) \
		INSTALLBINPATH=$(INSTALLBINPATH) \
		INSTALLBINMODE=$(INSTALLBINMODE) \
		INSTALLINCPATH=$(INSTALLINCPATH) \
		INSTALLINCMODE=$(INSTALLINCMODE) \
		INSTALLLIBPATH=$(INSTALLLIBPATH) \
		INSTALLSHAPELIBPATH=$(INSTALLSHAPELIBPATH) \
		INSTALLLIBMODE=$(INSTALLLIBMODE) \
		INSTALLMANPATH=$(INSTALLMANPATH) \
		INSTALLMANMODE=$(INSTALLMANMODE) \
		LOCALLIBPATH=$(LOCALLIBPATH) \
		LOCALINCLUDEPATH=$(LOCALINCLUDEPATH) \
		MAKE="$(MAKE)" \
		SHELL="$(SHELL)" \
		CC="$(CC)" \
		CFLAGS="$(CFLAGS)" \
		LDFLAGS="$(LDFLAGS)" \
		RANLIB="$(RANLIB)" \
		SYSLIBS="$(SYSLIBS)" \
		BINDDEFAULT=$(BINDDEFAULT) \
		BINDINSTALL=$(BINDINSTALL) \
		COMPILER=$(COMPILER) \
		QUALITY=$(QUALITY) \
		TOTALRELEASEBASE=$(TOTALRELEASEBASE) \
		PARTIALRELEASEBASE=$(PARTIALRELEASEBASE) \
		SHAPELIBPATH=$(SHAPELIBPATH) \
		ALLTARGETS= \
		MAINTARGET= \
		$(MAINTARGET) ); \
	done

# --------------------------------------------------------------------
#			internals (do not modify)
# --------------------------------------------------------------------

install: +install $(ALLTARGETS)

localinstall: +localinstall $(ALLTARGETS)

clean: +clean $(ALLTARGETS)

+all:
	@-if [ -n "$(ALLTARGETS)" ]; \
	then : ; \
	else \
	  $(MAKE) ALLTARGETS="subsystems targets" MAINTARGET=all \
		BASE=$(BASE) \
		HOSTSYSTEM=$(HOSTSYSTEM) \
		HOSTTYPE=$(HOSTTYPE) \
		INSTALLBASE=$(INSTALLBASE) \
		INSTALLBINPATH=$(INSTALLBINPATH) \
		INSTALLBINMODE=$(INSTALLBINMODE) \
		INSTALLINCPATH=$(INSTALLINCPATH) \
		INSTALLINCMODE=$(INSTALLINCMODE) \
		INSTALLLIBPATH=$(INSTALLLIBPATH) \
		INSTALLSHAPELIBPATH=$(INSTALLSHAPELIBPATH) \
		INSTALLLIBMODE=$(INSTALLLIBMODE) \
		INSTALLMANPATH=$(INSTALLMANPATH) \
		INSTALLMANMODE=$(INSTALLMANMODE) \
		LOCALLIBPATH=$(LOCALLIBPATH) \
		LOCALINCLUDEPATH=$(LOCALINCLUDEPATH) \
		MAKE="$(MAKE)" \
		SHELL="$(SHELL)" \
		CC="$(CC)" \
		CFLAGS="$(CFLAGS)" \
		LDFLAGS="$(LDFLAGS)" \
		RANLIB="$(RANLIB)" \
		SYSLIBS="$(SYSLIBS)" all; \
	fi

+install:
	@-if [ -n "$(ALLTARGETS)" ]; \
	then : ; \
	else \
	  $(MAKE) ALLTARGETS="subsystems installtargets" \
		MAINTARGET=install \
		BASE=$(BASE) \
		HOSTSYSTEM=$(HOSTSYSTEM) \
		HOSTTYPE=$(HOSTTYPE) \
		INSTALLBASE=$(INSTALLBASE) \
		INSTALLBINPATH=$(INSTALLBINPATH) \
		INSTALLBINMODE=$(INSTALLBINMODE) \
		INSTALLINCPATH=$(INSTALLINCPATH) \
		INSTALLINCMODE=$(INSTALLINCMODE) \
		INSTALLLIBPATH=$(INSTALLLIBPATH) \
		INSTALLSHAPELIBPATH=$(INSTALLSHAPELIBPATH) \
		INSTALLLIBMODE=$(INSTALLLIBMODE) \
		INSTALLMANPATH=$(INSTALLMANPATH) \
