=== src/sttk/Makefile ===
## Copyright (C) 1993,1994 by the author(s).
# 
# This software is published in the hope that it will be useful, but
# WITHOUT ANY WARRANTY for any part of this software to work correctly
# or as described in the manuals. See the ShapeTools Public License
# for details.
#
# Permission is granted to use, copy, modify, or distribute any part of
# this software but only under the conditions described in the ShapeTools 
# Public License. A copy of this license is supposed to have been given
# to you along with ShapeTools in a file named LICENSE. Among other
# things, this copyright notice and the Public License must be
# preserved on all copies.

#
# Makefile for ShapeTools toolkit library (sttk)
#
# Authors: Andreas Lampen (Andreas.Lampen@cs.tu-berlin.de)
#          Axel Mahler (Axel.Mahler@cs.tu-berlin.de)
#
# $Header: Makefile[4.0] Fri Jul 30 16:00:00 1993 andy@cs.tu-berlin.de frozen $
#

# --------------------------------------------------------------------
#		locations and general macros
# --------------------------------------------------------------------

# The base directory of the project's repository area.

BASE = /home/stone/shape/development

# Path to this node system relative to the root of the
# repository area defined above (e.g. src/vc/save).

NODEPATH = src/sttk

# A short name for this node system

NODENAME = sttk

# The operating system, $(TARGET) shall be built for.

HOSTSYSTEM = s_sunos_4

# The processor type.

HOSTTYPE = sun4

# Preprocessor switches. (eg. -DDEBUG)

SWITCHES = 

# Locations and modes for the installation of executables, header
# files, libraries and manuals.

INSTALLBASE = /home/stone/shape
INSTALLBINPATH = $(INSTALLBASE)/bin
INSTALLBINMODE = 755
INSTALLINCPATH = $(INSTALLBASE)/include
INSTALLINCMODE = 444
INSTALLLIBPATH = $(INSTALLBASE)/lib
INSTALLLIBMODE = 644
INSTALLMANPATH = $(INSTALLBASE)/man
INSTALLMANMODE = 444

# Directories, where local libraries and header files are to be
# installed for project wide use.

LOCALLIBPATH     = $(BASE)/lib
LOCALINCLUDEPATH = $(BASE)/include

# --------------------------------------------------------------------
#		the system's components
# --------------------------------------------------------------------

#
# The system (program, library, etc.) to be built. If you want to
# manage multiple programs, you should introduce multiple targets
# (like PROGTARGET LIBTARGET or any better names). In this case you 
# have to adjust the system building actions accordingly.

LIBTARGET = libsttk.a

# The release number generator. The version number of this file will
# be used as release identifier for the whole system.

VERSIONFILE = sttk_version.c	# source
VERSIONOBJECT =	sttk_version.o	# derived (if source contains program code)

# The names of the subdirectories containing subsystems which are also
# to be built.

SUBSYSTEMS = 

# Aliases for (filesystem links to) $(TARGET).

ALIASES = 

# The regular source and header files.

SOURCES = strtab.c files.c kbdio.c mktime.c parseargs.c \
		ststring.c sighand.c call.c

HEADERS = sttk.h

# Auxiliary source and header files that are not genuine part of the
# system (eg. a test environment). These will also be processed on
# system building, but will *not* be included in releases.

AUXSOURCES = 

AUXHEADERS = 

# Sources of variant source components stored under equal names in
# different locations. During system builds, only one of each (equally
# named) group is chosen. Source distributions need all of them.

VARIANTSOURCES =

VARIANTHEADERS =

# The manuals

MANUALS = $(MAN1) $(MAN3) $(MAN4) $(MAN5) $(MAN6) $(MAN7) $(MAN8)
MAN1 =
MAN3 = sttkintro.3 stcall.3 stparseargs.3 stsignal.3 ststring.3 \
	sttime.3 sttmpfiles.3 sttransaction.3 stuserio.3
MAN4 = 
MAN5 = 
MAN6 = 
MAN7 = 
MAN8 = 

# All source components of the system (should not be changed)

COMPONENTS = $(SOURCES) $(HEADERS) $(MANUALS) Shapefile Makefile Dependencies

# The derived files. All files, that are automatically produced during
# a build process should be listed here.

LIBOBJECTS = strtab.o files.o kbdio.o mktime.o parseargs.o \
		ststring.o sighand.o call.o $(VERSIONOBJECT)

# --------------------------------------------------------------------
#		tools, flags, libraries etc.
# --------------------------------------------------------------------

MAKE = make
SHELL = /bin/sh

INCLUDES = -I$(LOCALINCLUDEPATH)
MAKECFLAGS = -g
MAKELDFLAGS = -g

CC = cc
CFLAGS  = $(INCLUDES) $(MAKECFLAGS) $(SWITCHES)
LDFLAGS = $(MAKELDFLAGS)

RANLIB  = /usr/bin/ranlib

# System libraries, local libraries and lint libraries.

SYSLIBS   =
LOCALLIBS =
LINTLIBS  =

# --------------------------------------------------------------------
#			the targets
# --------------------------------------------------------------------

# The default action (do not change)

all: +all $(ALLTARGETS)

# The final system building action.

targets: $(LIBTARGET)

$(LIBTARGET): $(LIBOBJECTS)
	-ar ruv $(LIBTARGET) $(LIBOBJECTS)
	@-($(RANLIB) $(LIBTARGET)) 2> /dev/null; true

localinstalltargets: $(LOCALLIBPATH)/$(LIBTARGET) \
		$(LOCALINCLUDEPATH)/sttk.h

$(LOCALLIBPATH)/$(LIBTARGET): $(LIBTARGET)
	@-echo "Copying $(LIBTARGET) to $(LOCALLIBPATH)"; \
	if [ -f $(LOCALLIBPATH)/$(LIBTARGET) ] ;\
	then \
	mv -f $(LOCALLIBPATH)/$(LIBTARGET) \
	      $(LOCALLIBPATH)/$(LIBTARGET).old;\
	fi; \
	cp $(LIBTARGET) $(LOCALLIBPATH)/$(LIBTARGET); \
	chmod $(INSTALLLIBMODE) $(LOCALLIBPATH)/$(LIBTARGET); \
	($(RANLIB) $(LOCALLIBPATH)/$(LIBTARGET)) 2> /dev/null; true

$(LOCALINCLUDEPATH)/sttk.h: sttk.h
	@-echo "Copying sttk.h to $(LOCALINCLUDEPATH)"; \
	if [ -f $(LOCALINCLUDEPATH)/sttk.h ] && \
	   [ ! -w $(LOCALINCLUDEPATH)/sttk.h ]; \
	then \
	  chmod u+w $(LOCALINCLUDEPATH)/sttk.h; \
	fi; \
	cp sttk.h $(LOCALINCLUDEPATH)/sttk.h; \
	chmod $(INSTALLINCMODE) $(LOCALINCLUDEPATH)/sttk.h

installtargets: $(INSTALLLIBPATH)/$(LIBTARGET) \
		$(INSTALLINCPATH)/sttk.h

$(INSTALLLIBPATH)/$(LIBTARGET): $(LIBTARGET)
	@-echo "Installing $(LIBTARGET) in $(INSTALLLIBPATH)"; \
	if [ -f $(INSTALLLIBPATH)/$(LIBTARGET) ] ;\
	then \
	mv -f $(INSTALLLIBPATH)/$(LIBTARGET) \
	      $(INSTALLLIBPATH)/$(LIBTARGET).old;\
	fi; \
	cp $(LIBTARGET) $(INSTALLLIBPATH)/$(LIBTARGET); \
	chmod $(INSTALLLIBMODE) $(INSTALLLIBPATH)/$(LIBTARGET); \
	($(RANLIB) $(INSTALLLIBPATH)/$(LIBTARGET)) 2> /dev/null; true

$(INSTALLINCPATH)/sttk.h: sttk.h
	@-echo "Installing sttk.h in $(INSTALLINCPATH)"; \
	if [ -f $(INSTALLINCPATH)/sttk.h ] && \
	   [ ! -w $(INSTALLINCPATH)/sttk.h ]; \
	then \
	  chmod u+w $(INSTALLINCPATH)/sttk.h; \
	fi; \
	cp sttk.h $(INSTALLINCPATH)/sttk.h; \
	chmod $(INSTALLINCMODE) $(INSTALLINCPATH)/sttk.h

installmanuals: $(MANUALS)
	@-_manuals="$(MAN1)"; \
	for i in $$_manuals; \
	do \
	  echo "installing $$i in $(INSTALLMANPATH)/man1"; \
	  if [ -f $(INSTALLMANPATH)/man1/$$i ] && \
	     [ ! -w $(INSTALLMANPATH)/man1/$$i ]; \
	  then \
	    chmod u+w $(INSTALLMANPATH)/man1/$$i; \
	  fi; \
	  cp $$i $(INSTALLMANPATH)/man1/$$i; \
	  chmod $(INSTALLMANMODE) $(INSTALLMANPATH)/man1/$$i; \
	done

# The cleanup action. Removes all automatically rederivable files.

doclean:
	rm -f $(LIBTARGET) $(ALIASES) $(LIBOBJECTS)

# Do nothing

noinstall:
	@true

# Recursive builds. Performed *before* building $(TARGET)

subsystems:
	@_subsystems="$(SUBSYSTEMS)"; \
	for i in $$_subsystems; \
	do \
	  echo cd $$i; \
	  (cd $$i; $(MAKE) \
		BASE=$(BASE) \
		HOSTSYSTEM=$(HOSTSYSTEM) \
		HOSTTYPE=$(HOSTTYPE) \
		INSTALLBASE=$(INSTALLBASE) \
		INSTALLBINPATH=$(INSTALLBINPATH) \
		INSTALLBINMODE=$(INSTALLBINMODE) \
		INSTALLINCPATH=$(INSTALLINCPATH) \
		INSTALLINCMODE=$(INSTALLINCMODE) \
		INSTALLLIBPATH=$(INSTALLLIBPATH) \
		INSTALLLIBMODE=$(INSTALLLIBMODE) \
		INSTALLMANPATH=$(INSTALLMANPATH) \
		INSTALLMANMODE=$(INSTALLMANMODE) \
		LOCALLIBPATH=$(LOCALLIBPATH) \
		LOCALINCLUDEPATH=$(LOCALINCLUDEPATH) \
		MAKE="$(MAKE)" \
		SHELL="$(SHELL)" \
		CC="$(CC)" \
		CFLAGS="$(CFLAGS)" \
		LDFLAGS="$(LDFLAGS)" \
		RANLIB="$(RANLIB)" \
		SYSLIBS="$(SYSLIBS)" \
		BINDDEFAULT=$(BINDDEFAULT) \
		BINDINSTALL=$(BINDINSTALL) \
		COMPILER=$(COMPILER) \
		QUALITY=$(QUALITY) \
		TOTALRELEASEBASE=$(TOTALRELEASEBASE) \
		PARTIALRELEASEBASE=$(PARTIALRELEASEBASE) \
		SHAPELIBPATH=$(SHAPELIBPATH) \
		ALLTARGETS= \
		MAINTARGET= \
		$(MAINTARGET) ); \
	done

# --------------------------------------------------------------------
#			internals (do not modify)
# --------------------------------------------------------------------

install: +install $(ALLTARGETS)

localinstall: +localinstall $(ALLTARGETS)

clean: +clean $(ALLTARGETS)

+all:
	@-if [ -n "$(ALLTARGETS)" ]; \
	then : ; \
	else \
	  $(MAKE) ALLTARGETS="subsystems targets" MAINTARGET=all \
		BASE=$(BASE) \
		HOSTSYSTEM=$(HOSTSYSTEM) \
		HOSTTYPE=$(HOSTTYPE) \
		INSTALLBASE=$(INSTALLBASE) \
		INSTALLBINPATH=$(INSTALLBINPATH) \
		INSTALLBINMODE=$(INSTALLBINMODE) \
		INSTALLINCPATH=$(INSTALLINCPATH) \
		INSTALLINCMODE=$(INSTALLINCMODE) \
		INSTALLLIBPATH=$(INSTALLLIBPATH) \
		INSTALLLIBMODE=$(INSTALLLIBMODE) \
		INSTALLMANPATH=$(INSTALLMANPATH) \
		INSTALLMANMODE=$(INSTALLMANMODE) \
		LOCALLIBPATH=$(LOCALLIBPATH) \
		LOCALINCLUDEPATH=$(LOCALINCLUDEPATH) \
		MAKE="$(MAKE)" \
		SHELL="$(SHELL)" \
		CC="$(CC)" \
		CFLAGS="$(CFLAGS)" \
		LDFLAGS="$(LDFLAGS)" \
		RANLIB="$(RANLIB)" \
		SYSLIBS="$(SYSLIBS)" all; \
	fi

+install:
	@-if [ -n "$(ALLTARGETS)" ]; \
	then : ; \
	else \
	  $(MAKE) ALLTARGETS="subsystems installtargets" \
		MAINTARGET=install \
		BASE=$(BASE) \
		HOSTSYSTEM=$(HOSTSYSTEM) \
		HOSTTYPE=$(HOSTTYPE) \
		INSTALLBASE=$(INSTALLBASE) \
		INSTALLBINPATH=$(INSTALLBINPATH) \
		INSTALLBINMODE=$(INSTALLBINMODE) \
		INSTALLINCPATH=$(INSTALLINCPATH) \
		INSTALLINCMODE=$(INSTALLINCMODE) \
		INSTALLLIBPATH=$(INSTALLLIBPATH) \
		INSTALLLIBMODE=$(INSTALLLIBMODE) \
		INSTALLMANPATH=$(INSTALLMANPATH) \
		INSTALLMANMODE=$(INSTALLMANMODE) \
		LOCALLIBPATH=$(LOCALLIBPATH) \
		LOCALINCLUDEPATH=$(LOCALINCLUDEPATH) \
		MAKE="$(MAKE)" \
		SHELL="$(SHELL)" \
		CC="$(CC)" \
		CFLAGS="$(CFLAGS)" \
		LDFLAGS="$(LDFLAGS)" \
		RANLIB="$(RANLIB)" \
		SYSLIBS="$(SYSLIBS)" install; \
	fi

+localinstall:
	@-if [ -n "$(ALLTARGETS)" ]; \
	then : ; \
	else \
	  $(MAKE) ALLTARGETS="subsystems localinstalltargets" \
		MAINTARGET=install \
		BASE=$(BASE) \
		HOSTSYSTEM=$(HOSTSYSTEM) \
		HOSTTYPE=$(HOSTTYPE) \
		INSTALLBASE=$(BASE) \
		INSTALLBINPATH=$(INSTALLBINPATH) \
		INSTALLBINMODE=$(INSTALLBINMODE) \
		INSTALLINCPATH=$(INSTALLINCPATH) \
		INSTALLINCMODE=$(INSTALLINCMODE) \
		INSTALLLIBPATH=$(INSTALLLIBPATH) \
		INSTALLLIBMODE=$(INSTALLLIBMODE) \
		INSTALLMANPATH=$(INSTALLMANPATH) \
		INSTALLMANMODE=$(INSTALLMANMODE) \
		LOCALLIBPATH=$(LOCALLIBPATH) \
		LOCALINCLUDEPATH=$(LOCALINCLUDEPATH) \
		MAKE="$(MAKE)" \
		SHELL="$(SHELL)" \
		CC="$(CC)" \
		CFLAGS="$(CFLAGS)" \
		LDFLAGS="$(LDFLAGS)" \
		RANLIB="$(RANLIB)" \
		SYSLIBS="$(SYSLIBS)" localinstall; \
	fi

+clean:
	@-if [ -n "$(ALLTARGETS)" ]; \
	then : ; \
	else \
	  $(MAKE) ALLTARGETS="subsystems doclean" MAINTARGET=clean \
		BASE=$(BASE) \
		HOSTSYSTEM=$(HOSTSYSTEM) \
		HOSTTYPE=$(HOSTTYPE) \
		INSTALLBASE=$(BASE) \
		INSTALLBINPATH=$(INSTALLBINPATH) \
		INSTALLBINMODE=$(INSTALLBINMODE) \
		INSTALLINCPATH=$(INSTALLINCPATH) \
		INSTALLINCMODE=$(INSTALLINCMODE) \
		INSTALLLIBPATH=$(INSTALLLIBPATH) \
		INSTALLLIBMODE=$(INSTALLLIBMODE) \
		INSTALLMANPATH=$(INSTALLMANPATH) \
		INSTALLMANMODE=$(INSTALLMANMODE) \
		LOCALLIBPATH=$(LOCALLIBPATH) \
		LOCALINCLUDEPATH=$(LOCALINCLUDEPATH) \
		MAKE="$(MAKE)" \
		SHELL="$(SHELL)" \
		CC="$(CC)" \
		CFLAGS="$(CFLAGS)" \
		LDFLAGS="$(LDFLAGS)" \
		RANLIB="$(RANLIB)" \
		SYSLIBS="$(SYSLIBS)" clean; \
	fi
