=== debian/changelog ===
shapetools (1.4pl6-17) unstable; urgency=medium

  * Build with -std=gnu11. Closes: #1075506.
  * Fix build with newer autoconf.
  * Build using debhelper-compat 13.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Mon, 16 Feb 2026 10:23:31 +0100

shapetools (1.4pl6-16.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062894

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 15:48:26 +0000

shapetools (1.4pl6-16) unstable; urgency=medium

  * Upgrade to 3.0 source format. Closes: #1007676.
  * Don't embed build path in sttk.h (Vagrant Cascadian). Closes: #1020754.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Wed, 23 Aug 2023 16:03:32 +0200

shapetools (1.4pl6-15) unstable; urgency=medium

  * Fix build failure with glibc 2.32 (Logan Rosen). Closes: #986770.
  * Bump debhelper and standards versions.

 -- Matthias Klose <doko@debian.org>  Wed, 17 Nov 2021 17:58:03 +0100

shapetools (1.4pl6-14) unstable; urgency=medium

  * Bump debhelper and standards versions.

 -- Matthias Klose <doko@debian.org>  Thu, 19 Jan 2017 16:04:04 +0100

shapetools (1.4pl6-13) unstable; urgency=medium

  * Bump debhelper level to 5. Closes: #800249.

 -- Matthias Klose <doko@debian.org>  Mon, 12 Oct 2015 01:08:56 +0200

shapetools (1.4pl6-12) unstable; urgency=medium

  * Update standards version.
  * Fix some lintian warnings.
  * Build using dpkg-buildflags.

 -- Matthias Klose <doko@debian.org>  Sat, 15 Aug 2015 10:25:36 +0200

shapetools (1.4pl6-11) unstable; urgency=low

  * Fix build failure with eglibc-2.10. Closes: #552823.

 -- Matthias Klose <doko@debian.org>  Thu, 31 Dec 2009 16:59:46 +0100

shapetools (1.4pl6-10) unstable; urgency=low

  * Fix build error with glibc-2.7 on amd64. Closes: #454875.
  * Fix some lintian warnings.

 -- Matthias Klose <doko@debian.org>  Sat, 08 Dec 2007 08:08:03 +0000

shapetools (1.4pl6-9) unstable; urgency=low

  * Fix shapetools package dependency.
  * Add watch file.

 -- Matthias Klose <doko@debian.org>  Sun, 19 Sep 2004 20:22:19 +0200

shapetools (1.4pl6-8) unstable; urgency=low

  * Fix implicit pointer conversions (closes: #226648).

 -- Matthias Klose <doko@debian.org>  Thu,  8 Jan 2004 07:02:12 +0100

shapetools (1.4pl6-7) unstable; urgency=low

  * Fix vp(1) man page (closes: #210618).
  * Improve package description (closes: #209429).
  * Add missing man pages.
  * Move shared libraries to its own package (closes: #145888).

 -- Matthias Klose <doko@debian.org>  Mon, 22 Sep 2003 22:25:32 +0200

shapetools (1.4pl6-6) unstable; urgency=low

  * Add symlinks for all names in man pages (closes: #99552, #99539).

 -- Matthias Klose <doko@debian.org>  Sat, 21 Jul 2001 21:00:58 +0200

shapetools (1.4pl6-5) unstable; urgency=low

  * Recompiled with glibc-2.2.
  * Updated standards version.
  * Fix build failure (#84589).

 -- Matthias Klose <doko@debian.org>  Fri, 13 Apr 2001 01:31:40 +0200

shapetools (1.4pl6-4) unstable; urgency=low

  * usr/doc -> usr/share/doc transition.
  * Install man pages in /zsr/share/man.

 -- Matthias Klose <doko@cs.tu-berlin.de>  Sun,  5 Dec 1999 18:26:46 +0100

shapetools (1.4pl6-3) frozen unstable; urgency=low

  * Link shared libraries against libc.
  * debian/control: Fix typo.

 -- Matthias Klose <doko@cs.tu-berlin.de>  Thu, 26 Nov 1998 22:40:11 +0200

shapetools (1.4pl6-2) frozen unstable; urgency=low

  * Changed config.h to acconfig.h in _all_ source files (fixes #28185),
    so that the package can be compiled without installed atfs-dev.
  * Use cc instead of egcc for compiling.

 -- Matthias Klose <doko@cs.tu-berlin.de>  Mon, 19 Oct 1998 15:25:52 +0200

shapetools (1.4pl6-1) unstable; urgency=low

  * Initial Release.
  * Applied various patches collected ...

 -- Matthias Klose <doko@cs.tu-berlin.de>  Fri,  4 Sep 1998 15:18:43 +0200
