=== debian/control ===
Source: shapetools
Section: devel
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Standards-Version: 4.7.3
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)

Package: shapetools
Section: devel
Architecture: any
Depends: atfs (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Configuration and Release management using AtFS
 ShapeTools is a collection of programs to support software
 configuration management in an UNIX environment. It consists of a set
 of version and attribute control commands, and a configuration
 interpreter and build tool ("shape"). The toolkit is integrated on top
 of the Attributed File System (AtFS).
 .
 ShapeTools is designed to live meaningfully together
 with any other UNIX tool operating on regular files. This distribution
 also contains a prototype for a comprehensive change control and
 release management system designed to manage the evolution of system
 releases in multi programmer software development efforts.
Homepage: http://swt.cs.tu-berlin.de/~shape/index.html

Package: atfs
Section: devel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Attributed File System (AtFS)
 AtFS is a storage system supporting multiple versions of files and
 associating an arbitrary number of application defined attributes
 of the form "name=value" with each version. AtFS comes as a function
 library that is meant as an extension to the UNIX file system. It does
 this without the need for kernel modifications and without imposing any
 restrictions to existing file system applications. It is part of ShapeTools,
 a software configuration management system.
Homepage: http://swt.cs.tu-berlin.de/~shape/index.html

Package: libatfs1t64
Provides: ${t64:Provides}
Replaces: libatfs1
Breaks: libatfs1 (<< ${source:Version})
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Attributed File System (AtFS runtime libraries)
 AtFS is a storage system supporting multiple versions of files and
 associating an arbitrary number of application defined attributes
 of the form "name=value" with each version. It is part of ShapeTools, a
 software configuration management system.
 .
 This package contains the runtime libararies.
Homepage: http://swt.cs.tu-berlin.de/~shape/index.html

Package: atfs-dev
Section: libdevel
Architecture: any
Depends: atfs (= ${binary:Version}), ${misc:Depends}
Description: Attributed File System (AtFS development libraries)
 AtFS is a storage system supporting multiple versions of files and
 associating an arbitrary number of application defined attributes
 of the form "name=value" with each version. It is part of ShapeTools, a
 software configuration management system.
 .
 This package contains the development files needed to compile and link
 programs with AtFS.
Homepage: http://swt.cs.tu-berlin.de/~shape/index.html
